#lang racket

; Remove "prog".
; Replace "var" and "fun" with Racket's "define".
; Replace "set" with Racket's "set!".

;(prog
  (define makeIncrementor (lambda (inc)
                            (lambda (x) (+ x inc))))
(define incBy3 (makeIncrementor 3))
(define incBy5 (makeIncrementor 5))
(incBy3  6)
(incBy5  6)
(incBy3 -2)
(incBy5 -2)


;(prog
  (define makeCounter
      (lambda (x)   ; return a function with no parameters
         (lambda () (set! x (+ x 1)))))
 (define c1 (makeCounter 1))
 (define c2 (makeCounter 10))
 (c1)  ; call a function with no parameters
 (c1)
 (c1)
 (c2)
 (c2)
 (c2)
 (c1)
